# -*- coding: iso-8859-15 -*-

# Contractor, a contract validation tool
#    Copyright (C) 2008  Guido de Caso, Víctor Braberman, Diego Garbervetsky, Sebastián Uchitel
#    {gdecaso, vbraber, diegog, suchitel}@dc.uba.ar
#    LaFHIS - Departamento de Computación - Facultad de Ciencias Exactas y Naturales - Universidad de Buenos Aires
#    Pabellón I - Ciudad Universitaria - (C1428EGA) - Buenos Aires - Argentina
#    Tel: +54-11-4576-3390 eext. 704
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

def ltsa_write_fsm(fsm, contract, options):
	
	# write header
	print "// autogenerated with con2fsm"
	print ""
	
	# write contract name and link to initial state (if it exists)
	print contract.name + " =",
	if fsm.initial_state == None:
		print "STOP."
	else:
		print "S" + str(fsm.initial_state) + ","
		
		# write states
		states_size = len(fsm.states)
		for s in range(states_size):
			print "S" + str(fsm.states[s].name) + " =", 
			print "    /* invariant: " + fsm.states[s].invariant + " */"
			
			# write transitions for this state
			transitions_size = len(fsm.states[s].transitions)
			if transitions_size == 0:
				print "STOP"
			else:
				print "    (",
				for t in range(transitions_size):
					if t > 0:
						print "    |",
					print fsm.states[s].transitions[t].action + " -> S" + str(fsm.states[s].transitions[t].destination),
					if fsm.states[s].transitions[t].violates_invariant:
						print "    /* violates contract invariant on destination */",
					if t < transitions_size - 1:
						print ""
				print ")",
		
			# comma or dot?
			if s < states_size - 1:
				print ","
			else:
				print "."
